package br.ufpe.lp3.locadora.cliente;

import br.ufpe.lp3.locadora.cliente.*;

/**
 * <p>Title: Locadora OnLine </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company:UFPE - CIN </p>
 * @author Helder Teixeira Rodrigues
 * @version 1.0
 */

public class CadastroClientes {

  private RepositorioClientesArray clientes;

 /**
  *construtor default da classe CadastroClientes
  *
  *Limitacao : Caso o parametro passado para
  *  construtor seja null lanca se uma excessao
  *@param Um repositorio de clientes
  */
  public CadastroClientes(RepositorioClientesArray r) {
	if (r == null) {
	  throw new IllegalArgumentException("Argumento lista clientes nula");
	} this.clientes = r;
  }

 /**
  * Este metodo permite alterar os campos de um cliente cadastrado
  */
  public void atualizarCliente(Cliente c) throws ClienteInexistenteException{
      clientes.atualizarCliente(c);
  }

 /**
  * Este metodo cadastra um determinado cliente
  * verificando se o mesmo existe
  *
  * Observacao: o metodo inserir da classe
  * repositorio ja verifica se um certo cliente
  * existe ou nao
  *
  * @param  Um Cliente
  */
  public void cadastrarCliente(Cliente c) throws ClienteExistenteException{
      String cpf = c.getCpf();
      if (!clientes.existeCliente(c)) { //existeCliente(cpf)) {
          clientes.cadastrarCliente(c);
      } else {
            throw new ClienteExistenteException("Cliente jah existente");
      }
  }

 /**
  *Este metodo remove um  possivel cliente
  *
  *Oberservacao: o metodo remover da classe
  * repositorio  dispensa verificao da pre exis
  * tencia de um certo cliente
  *
  *@param um Cliente
  */
  public void removerCliente(String codigo) throws ClienteInexistenteException{
	  clientes.removerCliente(codigo);
  }

 /**
  * @param codigo   O numero de cadastro do cliente
  * @param cpf      Um String contendo o cpf do cliente
  * @param nome     O nome completo do cliente
  */
  public Cliente procurarCliente(String codigo, String cpf, String nome)
        throws ClienteInexistenteException{
	return clientes.procurarCliente(codigo, nome, cpf);
  }

}
