/**
*projeto de sistemas de locadora
*
*Tipo: InteradorClientesArray
*
*/

package br.ufpe.lp3.locadora.cliente;

import br.ufpe.lp3.locadora.util.*;


/**
* Esta classe modela um forma de interacao
* com um conjunto de usuarios,seus metodos
* relacionam-se logicamente com o repositorio
* e a gui.
*
* @autor Maurikleber
*
* @copyright: Larcio, Maurikleber, Helder, Hlio
*/
public class InteradorClientesArray extends RepositorioClientesArray {
           //  implements InteradorClientesArray {



    private Cliente[] clientes;
    private int proximo;

    /**
    *construtor da classe interadorClientesArray
    *
    *Observacao: usar futuramente excessao aqui caso
    *  o parametro do construtor for null
    */
    public InteradorClientesArray(Cliente[] clientes ) {
        super();

        //tudo isto para que o campo arrayclientes da
        //super classe continue private e nao protected
        for(int i = 0;i  < clientes.length;i++){
            if(clientes[i] != null){
                super.cadastrarCliente(clientes[i]);
            }
        }
        this.clientes = clientes;
        proximo = 0;
    }

    /**
    * Este metodo adiciona um novo cliente ao conjunto
    * interavel,lembrar de inserir no repositorio apos fazer tal
    * coisa
    *
    * @param um Cliente
    */
    public void adicionar(Cliente cliente){
        super.cadastrarCliente(cliente);
        clientes = super.getInterador().clientes;


    }

    /**
    * este metodo diz se existe um proximo elemento no conjunto interavel
    *
    * @return true caso haja um proximo elemento false em caso contrario
    *
    */
    public boolean temProximo(){
        boolean haProximo = false;
        if (proximo <= (clientes.length - 1)
                && (clientes[proximo]!= null))
            haProximo = true;
        return haProximo;
    }

    /**
    *este metodo retorna o proximo elemento de um conjunto interavel
    *
    *@return o proximo cliente do conjunto
    */
    public Cliente proximo(){
       Cliente retorno = null;
       if(temProximo()){
           retorno = clientes[proximo];
           proximo++;
       }
       return  retorno;
    }
}