package br.ufpe.lp3.locadora.conta;

/**
 * <p>Title: Locadora OnLine </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company:UFPE - CIN </p>
 * @author Helder Teixeira Rodrigues
 * @version 1.0
 */

public class CadastroContas {
	private IRepositorioContas contas;

	public CadastroContas(IRepositorioContas r) {
	  if (r == null) {
		throw new IllegalArgumentException("Argumento repositorioContas nulo");
	  }
	  this.contas = r;
	}

	public void atualizar(ContaAbstrata c) throws ContaInexistenteException {
  	  contas.atualizar(c);
	}
	public void inserir(ContaAbstrata c) throws ContaExistenteException{
          if(!contas.existe(c.getNumero())){
	    contas.inserir(c);
          }else{
	    throw new ContaExistenteException(c.getNumero());
	  }
        }

	public void creditar(String n, double v)
          throws ContaInexistenteException{

	  ContaAbstrata c = contas.procurar(n);
	  c.creditar(v);
	}

	public void debitar(String n, double v)
          throws ContaInexistenteException, SaldoInsuficienteException{

	  ContaAbstrata c = contas.procurar(n);
	  c.debitar(v);
	}

	public void remover(String n) throws ContaInexistenteException{
  	  contas.remover(n);
	}

	public ContaAbstrata procurar(String n) throws ContaInexistenteException{
	  return contas.procurar(n);
	}

        public ColecaoContasIteravel procurarContas(String cpfCliente){
          return this.procurarContas(cpfCliente);
        }
}
