package br.ufpe.lp3.locadora.conta;

import br.ufpe.lp3.locadora.cliente.*;

/**
 * <p>Title: Locadora OnLine </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company:UFPE - CIN </p>
 * @author Helder Teixeira Rodrigues
 * @version 1.0
 */

public abstract class ContaAbstrata {
	private String numero;
	private double saldo;
	private Cliente cliente;

	public ContaAbstrata(String num) {
          numero = num;
          saldo = 0;
	}
	public ContaAbstrata(String num, double s) {
          numero = num;
          saldo = s;
	}
	public ContaAbstrata(String num, double s, Cliente c) {
          numero = num;
          saldo = s;
          cliente = c;
	}

	public void creditar(double valor){
	  saldo = saldo + valor;
	}
	public abstract void debitar(double valor)
          throws SaldoInsuficienteException;

	public Cliente getCliente(){
	  return cliente;
	}
	public String getNumero() {
	  return numero;
	}
	public double getSaldo() {
	  return saldo;
	}
	public void setCliente(Cliente cliente) {
	  if (cliente == null) {
		throw new IllegalArgumentException("Argumento cliente nulo");
	  }
	  this.cliente = cliente;
	}
	public void setNumero(String num) {
	  if (num == null) {
		throw new IllegalArgumentException("Argumento codigo nulo!");
	  }
	  this.numero = num;
	}
	public void setSaldo(double valor) {
	  saldo = valor;
	}
	public boolean equals(Object outraConta) {
	  boolean resultado = false;
	  if (outraConta instanceof Conta) {
		Conta temp = (Conta) outraConta;
		resultado = resultado && (this.numero.equals(temp.getNumero()));
	  }
	  return resultado;
	}
}
