package br.ufpe.lp3.locadora.dvd;

import br.ufpe.lp3.locadora.dvd.*;

/**
 * <p>Title: Locadora OnLine </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company:UFPE - CIN </p>
 * @author Hlio Jum Tonsho
 * @version 1.0
 */

public class CadastroDvd {

	private RepositorioDvdArray listaDvds;

	public CadastroDvd() {
		listaDvds = new RepositorioDvdArray();
	}

	public void cadastrar(Dvd dvd) {
		if (!listaDvds.existe(dvd)) {
			listaDvds.inserir(dvd);
		}
	}

	public void remover(Dvd dvd) {
		if (listaDvds.existe(dvd)) {
			listaDvds.remover(dvd);
		}
	}

	public void atualizar(Dvd dvd) {
		if (listaDvds.existe(dvd)) {
			listaDvds.atualizar(dvd);
		}
	}

	public RepositorioDvdArray procurar(String palavraChave) {

		RepositorioDvdArray retorno = new RepositorioDvdArray();

		if ( palavraChave != null ) {
			retorno = listaDvds.procurar(palavraChave);
		}
		return retorno;

	}

   	public Dvd procurarCodigo(String codigo) {

		Dvd retorno = null;

        if ( codigo != null ) {
			retorno = listaDvds.procurarCodigo(codigo);
		}
		return retorno;

	}


	public boolean existe(Dvd dvd) {
		return listaDvds.existe(dvd);
	}

	public String toString() {
		return (listaDvds.toString());
	}

}