package br.ufpe.lp3.locadora.dvd;

import java.util.*;
import java.lang.String;

/**
 * <p>Title: Locadora OnLine </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company:UFPE - CIN </p>
 * @author Hlio Jum Tonsho
 * @version 1.0
 */

public class Dvd extends br.ufpe.lp3.locadora.dvd.Filme {

	private String codigo;
	private double preco;
	private String situacao;
	private FichaTecnicaDvd ficha;
	private static int scodigo = 999;

	public Dvd(String titulo, String diretor, String categoria,
				String artistas) {
		super(titulo, diretor, categoria, artistas);
		scodigo++;
		this.codigo = "DVD - " + Integer.toString(scodigo);
		this.situacao = "Disponivel";
	}

	public Dvd(String titulo, String diretor, String categoria,
				String artistas, FichaTecnicaDvd ficha) {
		super(titulo, diretor, categoria, artistas);
		scodigo++;
		this.codigo = Integer.toString(scodigo);
		this.situacao = "Disponivel";
		this.ficha = ficha;
	}

	public String getTitulo() {
		return titulo;
	}

	public void setTitulo(String titulo) {
		this.titulo = titulo ;
	}

	public String getDiretor() {
		return diretor;
	}

	public void setDiretor(String diretor) {
		this.diretor = diretor;
	}

	public String getCategoria() {
		return categoria;
	}

	public void setCategoria(String categoria) {
		this.categoria = categoria;
	}

	public String getArtistas() {
		return artistas;
	}

	public void setArtistas(String artistas) {
		this.artistas = artistas;
	}

	public String getCodigo() {
		return codigo;
	}

	public void setCodigo(String codigo) {
		this.codigo = codigo;
	}

	public String getSituacao() {
		return situacao;
	}

	public void setSituacao(String situacao) {
		this.situacao = situacao;
	}

	public String toString() {
		return( "\nCodigo: " + this.getCodigo()
				+"\nTitulo: " + this.getTitulo()
				+ "\nDiretor: " + this.getDiretor()
				+ "\nCategoria: " + this.getCategoria()
				+ "\nAtores principais: " + this.getArtistas()
				+ "\nSituacao: " + this.getSituacao() );
	}

	public boolean equals(Dvd dvd) {
		return ( this.getCodigo().equals(dvd.getCodigo())
				&& this.getTitulo().equals(dvd.getTitulo())
				&& this.getDiretor().equals(dvd.getDiretor())
				&& this.getCategoria().equals(dvd.getCategoria()) );
	}

}