package br.ufpe.lp3.locadora.dvd;


/**
 * <p>Title: Locadora OnLine </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company:UFPE - CIN </p>
 * @author Hlio Jum Tonsho
 * @version 1.0
 */

public abstract class Filme {

    public String titulo;          // Titulo em portugues
    public String diretor;         // Nome do(a) diretor(a)
    public String categoria;       // Lancamento, catalogo ou promocao
    public String artistas;        // Nome do artista principal

    public Filme (String titulo, String diretor, String categoria,
                  String artistas) {
       this.titulo = titulo;
       this.diretor = diretor;
       this.categoria = categoria;
       this.artistas = artistas;
    }

   /**
    * Retorna a categoria do Filme
    *
    * @return       Uma String: Lancamento, Catalogo ou Promocao
    */
    public String getCategoria(){
        return categoria;
    }

   /**
    * Ajusta a categoria do Filme
    *
    * @param        Uma String contendo a categoria do Filme
    */
    public void setCategoria (String categoria){
        this.categoria = categoria;
    }

   /**
    * Retorna o nome do ator(atriz) principal do filme
    *
    * Em tempo oportuno o atributo artistas sera implementado como Array.
    * Isso para que possamos ter mais que um artista principal
    *
    * @return       Uma String contendo o nome do(a) artista
    */
    public String getArtistas() {
        return artistas;
    }

   /**
    * Ajusta o nome do ator(atriz) principal do filme
    *
    * @param        Uma String contendo o nome do(a) artista
    */
    public void setArtistas (String artistas) {
        this.artistas = artistas;
    }

   /**
    * Retorna o nome do diretor do filme
    *
    * @return       Uma String contendo o nome do diretor do filme
    */
    public String getDiretor(){
        return diretor;
    }

   /**
    * Ajusta o nome do diretor do filme
    *
    * @param        Uma String contendo o nome do diretor do filme
    */
    public void setDiretor(String diretor) {
        this.diretor = diretor;
    }

   /**
    * Retorna o titulo do Filme (em portugues)
    *
    * @return       Uma String contendo o titulo do filme na lingua portuguesa
    */
    public String getTitulo(){
        return titulo;
    }

   /**
    * Ajusta o titulo do Filme
    *
    * @param        Uma String contendo o titulo do filme (em portugues)
    */
    public void setTitulo (String titulo) {
        this.titulo = titulo ;
    }
}