package br.ufpe.lp3.locadora.dvd;

import br.ufpe.lp3.locadora.dvd.*;

/**
 * <p>Title: Locadora OnLine </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company:UFPE - CIN </p>
 * @author Hlio Jum Tonsho
 * @version 1.0
 */

public class RepositorioDvdArray {

	private Dvd[] dvds;
	private int indice;
	private int tamanho;

	public RepositorioDvdArray() {
		tamanho = 1;
		dvds = new Dvd[tamanho];
		indice = 0;
	}

	public boolean existe(Dvd dvd) {

		int i;
		boolean retorno = false;

		for (i = 0; i < indice; i++) {
			if (dvds[i] != null){
				if (dvd.equals(dvds[i])) {
					retorno =  true;
				}
			}
		}
		return retorno;

	}

	public void inserir(Dvd dvd) {

		int i;
		Dvd[] dvdsTemp;

		if( indice == tamanho ) {

			dvdsTemp = dvds;
			tamanho = tamanho + 20;
			dvds = new Dvd[tamanho];

			for (i = 0; i < indice; i++) {
				dvds[i] = dvdsTemp[i];
			}
		}

		dvds[indice] = dvd;
		this.indice++;
	}

	public void remover(Dvd dvd) {

		int i;

		if ( dvd != null ) {
			for (i = 0; i < indice; i++) {
				if (dvds[i].equals(dvd) ) {
					dvds[i] = dvds[indice - 1];
					dvds[indice-1] = null;
					indice = indice - 1;
					return;
				}
			}
		}

	}

	public void atualizar(Dvd dvd) {

		int i;

		for (i = 0; i < indice; i++) {
			if (dvds[i].equals(dvd)) {
				dvds[i] = dvd;
			return;
			}
		}

	}


	public RepositorioDvdArray procurar(String palavraChave) {

		int i;
		RepositorioDvdArray repositorioAchados = new RepositorioDvdArray();

		boolean a = false;
		boolean b = false;
		boolean c = false;

		for (i = 0; i < indice; i++) {
			if ( dvds[i].getArtistas() != null ) {
				a = dvds[i].getArtistas().equalsIgnoreCase(palavraChave);
			}
			if ( dvds[i].getDiretor() != null ) {
				b = dvds[i].getDiretor().equalsIgnoreCase(palavraChave);
			}
			if ( dvds[i].getTitulo() != null ) {
				c = dvds[i].getTitulo().equalsIgnoreCase(palavraChave);
			}
			if ( a || b || c ) {
				repositorioAchados.inserir(dvds[i]);
			}
		}
		return repositorioAchados;

	}

    public Dvd procurarCodigo(String codigo) {

        int i;
        Dvd dvd = null;
        boolean a = false;
        for (i=0; i < indice; i++) {
            if ( dvds[i].getCodigo() != null ) {
                a = dvds[i].getCodigo().equalsIgnoreCase(codigo);
                if (a) return dvd;
            }
        } return dvd;
    }


	public String toString() {

		int i;
		String s = "";

		for (i = 0; i < indice; i++) {
			s = s + "\nCodigo: " + dvds[i].getCodigo()
				+ "\nTitulo: " + dvds[i].getTitulo()
				+ "\nDiretor: " + dvds[i].getDiretor()
				+ "\nArtistas: " + dvds[i].getArtistas()
				+ "\nSituacao: " + dvds[i].getSituacao() + "\n";
		}
		return s;

	}

}