/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @authors Helder Teixeira Rodrigues e Hlio Jum Tonsho
 * @version	1.0
 */
package	br.ufpe.lp3.locadora.fachada;

import br.ufpe.lp3.locadora.dvd.*;
import br.ufpe.lp3.locadora.cliente.*;
import br.ufpe.lp3.locadora.pedido.*;
import br.ufpe.lp3.locadora.util.*;
import br.ufpe.lp3.locadora.conta.*;
import java.util.Calendar;
import java.util.GregorianCalendar;

public class Fachada {

//	private	int	n;
	private	CadastroDvd	cadastroDvd;
	private	CadastrarReserva cadastroReserva;
	private	CadastrarLocacao cadastroLocacao;
	private	CadastrarClientes cadastroClientes;
	private	static Fachada instancia;
	private	CadastroContas contas;
	private	CadastrarClientes clientes;

	public Fachada() {
		cadastrarDvd = new CadastroDvd();
		cadastrarLocacao = new CadastrarLocacao();
		cadastrarReserva = new CadastrarReserva();
		cadastrarClientes = new CadastrarClientes();
	}

	private	void initCadastros() {
		IRepositorioContas rep = new ArrayContas();
		contas = new CadastroContas(rep);
		IRepositorioClientes repClientes = new ListaClientes();
		clientes = new CadastrarClientes(repClientes);
	}

	public static Fachada obterInstancia() {
		if (instancia == null) {
			instancia =	new	Fachada();
		}
		return instancia;
	}


/*
  //metodos	para manipular clientes
  public void inserir(Cliente c) throws	ClienteExistenteException{
		clientes.inserir(c);
  }
  public void removerCliente(String	cpf) throws	ClienteInexistenteException{
		  clientes.remover(cpf);
  }

//	public void	locar(Dvd d, Cliente c)	throws {
//
//	}

  //metodos	para manipular contas
  public void atualizar(ContaAbstrata c) throws	ContaInexistenteException{
		contas.atualizar(c);
  }
  public ContaAbstrata procurarConta(String	n) throws ContaInexistenteException{
		  return contas.procurar(n);
  }
  public void inserir(ContaAbstrata	c)
	throws ContaExistenteException,	ClienteInexistenteException{

	Cliente	cli	= c.getCliente();
	if(cli != null){
	  cli =	clientes.procurar(cli.getCpf());
	  c.setCliente(cli);
	  contas.inserir(c);
	} else {
	  throw	new	ClienteInexistenteException("Cliente nao cadastrado");
	}
  }
  public void removerConta(String n) throws	ContaInexistenteException{
		  contas.remover(n);
  }
  public void creditar(String n, double	v) throws ContaInexistenteException{
	contas.creditar(n, v);
  }
  public void debitar(String n,	double v)
	throws ContaInexistenteException, SaldoInsuficienteException{

	contas.debitar(n, v);
  }
  public void transferir(String	origem,	String destino,	double val)
	throws ContaInexistenteException, SaldoInsuficienteException{

	  contas.transferir(origem,	destino, val);
  }
  public ColecaoContasIteravel procurarContas(String cpfCliente){
	return contas.procurarContas(cpfCliente);
  }

*/

	public CadastroDvd getCadastroDvd()	{
		return cadastroDvd;
	}

	public CadastrarReserva getCadastroReserva()	{
		return cadastroReserva;
	}

	public CadastrarLocacao getCadastroLocacao()	{
		return cadastroLocacao;
	}

	public CadastrarClientes getCadastroClientes() {
		return cadastroClientes;
	}


	/* Dvd */
	public void cadastrarDvd(Dvd dvd)	{
		if (dvd != null) {
			cadastroDvd.cadastrar(dvd);
		}
		else {
			throw new IllegalArgumentException("Esse dvd j	est cadastrado");
		}
	}

	public void	removerDvd(Dvd dvd)	{
		if (dvd	!= null) {
			cadastroDvd.remover(dvd);
		}
		else {
			throw new IllegalArgumentException("No	podemos	remover	o dvd");
		}
	}

	public boolean existeDvd(Dvd dvd) {
		if (dvd	!= null	) {
			return cadastroDvd.existe(dvd);
		}
		else {
			throw new IllegalArgumentException("No	pode procurar o	dvd");
		}
	}

	public Dvd procurarDvdCodigo(String	codigo)	{
		if (codigo != null)	{
			return cadastroDvd.procurarCodigo(codigo);
		}
		else {
			throw new IllegalArgumentException(" No pode procurar por um dvd");
		}
	}

	public RepositorioDvdArray procurar(String palavraChave) {
		if (palavraChave !=	null) {
			return cadastroDvd.procurar(palavraChave);
		}
		else {
			throw new IllegalArgumentException(" No pode procurar um dvd");
		}
	}

		/* Cliente */
/*		public void	cadastrarCliente(Cliente cliente) {

				if (cliente	!= null) {
						cadastroClientes.cadastrarCliente(cliente);
				} else {
						throw new ClienteExistenteException;
				}
		}

		public void	excluirCliente(Cliente cliente)	{

				if (cliente	!= null) {
						cadastroClientes.excluirCliente(cliente);
				} else {
						throw new ClienteInexistenteException;
				}
		}

		public boolean	existeCliente(Cliente cliente) {
		boolean	resultado =	false;

		if (cliente	!= null) {
				resultado =	cadastroClientes.existeCliente(cliente);
		} else {
				throw new ClienteInexistenteException;
		}

		return resultado;
		}

		public void	atualizar(Cliente c) throws	ClienteInexistenteException{
				cadastroClientes.atualizar(c);
		}

		public Cliente procurarCliente(String cpf) throws ClienteInexistenteException{
			  return cadastroClientes.procurarCpfCliente(cpf);
		}


	/* reserva */
	public void	cadastrarReserva(Reserva reserva) {
		if (reserva	!= null) {
			cadastroReserva.cadastrar(reserva);
		}
		else {
			throw new IllegalArgumentException("Exceo1: No pode cadastrar uma reserva null");
		}
	}

	public boolean existeReserva(Reserva reserva) {

		boolean	retorno;

		if (reserva != null ){
			retorno	= cadastroReserva.existe(reserva);
		}
		else {
			throw new IllegalArgumentException("Essa  reserva nao existe");
		}
		return retorno;

	}

	public void	excluirReserva(Reserva reserva)	{
		if (reserva != null){
			cadastroReserva.remover(reserva);
		}
		else {
			throw new IllegalArgumentException("Erro excluir");
		}
	}

	public boolean estaReservado(Dvd dvd, GregorianCalendar	data) {

		boolean	resultado;

		if (dvd != null && data != null ) {
			return cadastroReserva.estaReservado(dvd, data);
		}
		else {
			throw new IllegalArgumentException("Nao	pode reservar esse dvd");
		}
	}

	public boolean temReservaCliente(Cliente cliente, GregorianCalendar	data) {
		if (cliente != null && data != null)	{
			return cadastroReserva.temReservaCliente(cliente, data);
		}
		else {
			throw new IllegalArgumentException("Argumentos invalidos");
		}
	}

	/* locacao*/
	public void	cadastrarLocacao(Locacao locacao) {
		// Verifica	1 se a	locao	 nula,	levantando um execeo se for,
		// depois verifica se j existe	locacao	com	o codigo solicitado,
		// se o	carro solicitado j	est locado	e por ltimo se	o cliente
		// possui alguma locao em	aberto
		// Passando	dessas verificaes	a locao 	inserida no	cadastro
		if (locacao	!= null){
		cadastroLocacao.cadastrar(locacao);
		}
		else {
			throw new IllegalArgumentException("Nao	ha locacao invalida");
		}
	}

	public void	excluirLocacao(String codigo) {
		// Referncia a	locao	que	tem	tal	codigo (se existir)
		// pode	ser	uma	referncia nula, caso no exista locao com
		// esse	cdigo
		Locacao	locacao	= cadastroLocacao.procurarCodigo(codigo);

		if (locacao	!= null) {
			cadastroLocacao.remover(locacao);
		}
		else {
			throw new IllegalArgumentException("Nao ha	locacao	com	este codigo");
		}
	}

	public boolean estaLocadoDvd(Dvd dvd) {
		if (dvd	!= null) {
			return cadastroLocacao.estaLocado(dvd);
		}
		else {
			throw new IllegalArgumentException("Dvd invalido -	nulo!");
		}
	}

	public boolean temLocacaoCliente(Cliente cliente) {
		if (cliente	!= null) {
			return this.cadastroLocacao.temLocacaoCliente(cliente);
		}
		else {
			throw new IllegalArgumentException("Carro invalido -	nulo!");
		}
	}

	public boolean existeLocacao(Locacao locacao)	{
		return cadastroLocacao.existe(locacao);
	}
}

