package br.ufpe.lp3.locadora.pedido;

import java.util.*;
import java.util.GregorianCalendar;
import java.util.Calendar;
import java.lang.String;

/**
 * <p>Title: Locadora OnLine </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company:UFPE - CIN </p>
 * @author Hlio Jum Tonsho
 * @version 1.0
 */

public class CadastrarLocacao {

	private RepositorioLocacaoArray listaLocacoes;

	public CadastrarLocacao() {
		listaLocacoes = new RepositorioLocacaoArray();
	}

	public void cadastrar(Locacao locacao) {
		if (!listaLocacoes.existe(locacao)) {
			listaLocacoes.inserir(locacao);
		}
	}

	public void remover(Locacao locacao) {
		if (listaLocacoes.existe(locacao)) {
			listaLocacoes.remover(locacao);
		}
	}

	public void atualizar(Locacao locacao) {
		if (listaLocacoes.existe(locacao)) {
			listaLocacoes.atualizar(locacao);
		}
	}

	public RepositorioLocacaoArray procurar(String palavraChave) {

		RepositorioLocacaoArray retorno = new RepositorioLocacaoArray();

		if ( palavraChave != null ) {
			retorno = listaLocacoes.procurar(palavraChave);
		}
		return retorno;

	}

	public RepositorioLocacaoArray procurarData(GregorianCalendar data) {

		RepositorioLocacaoArray retorno = new RepositorioLocacaoArray();

		if ( data != null ) {
			retorno = listaLocacoes.procurarData(data);
		}
		return retorno;

	}

	public boolean existe(Locacao locacao) {
		return listaLocacoes.existe(locacao);
	}

	public String toString() {
		return (listaLocacoes.toString());
	}

}