package br.ufpe.lp3.locadora.pedido;

import java.util.GregorianCalendar;
import br.ufpe.lp3.locadora.pedido.*;
import br.ufpe.lp3.locadora.cliente.*;

/**
 * <p>Title: Locadora OnLine </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company:UFPE - CIN </p>
 * @author Hlio Jum Tonsho
 * @version 1.0
 */

public class CadastrarReserva {

        private Reserva[] reservas;
	private int indice;
	private int tamanho;
        private RepositorioReservaArray listaReservas;

        public boolean estaReservado(Reserva reserva) {

        int i;
        boolean retorno = false;

        for (i=0; i < indice; i++) {
                if (reservas[i] != null) {
                        if ( reserva.getDvd().equals(reservas[i].getDvd())
                                && reserva.getData().equals(reservas[i].getData()) ) {
                                        retorno = true;
                        }
                }
        }
        return retorno;

	}


        public CadastrarReserva() {
		listaReservas = new RepositorioReservaArray();
	}

	public void cadastrar(Reserva reserva) {
		if (!listaReservas.existe(reserva)) {
                    if (reserva.getDvd().getSituacao().equals("Disponivel")) {
			listaReservas.inserir(reserva);
                    }
		}
	}

	public void remover(Reserva reserva) {
		if (listaReservas.existe(reserva)) {
			listaReservas.remover(reserva);
		}
	}

	public void atualizar(Reserva reserva) {
		if (listaReservas.existe(reserva)) {
			listaReservas.atualizar(reserva);
		}
	}

	public RepositorioReservaArray procurar(String palavraChave) {

		RepositorioReservaArray retorno = new RepositorioReservaArray();

		if ( palavraChave != null ) {
			retorno = listaReservas.procurar(palavraChave);
		}
		return retorno;

	}

	public Reserva procurarCodigoDvd(String codigo) {

		Reserva retorno = null;
		if ( codigo != null ) {
			retorno = listaReservas.procurarCodigoDvd(codigo);
		}
		return retorno;
	}

//	public boolean clienteTemReserva(Locacao locacao) {
//
//		boolean retorno = false;
//		if ( locacao != null ) {
//			retorno = listaReservas.clienteTemReserva(locacao);
//		}
//		return retorno;
//	}

	public RepositorioReservaArray procurarData(GregorianCalendar data) {

		RepositorioReservaArray retorno = new RepositorioReservaArray();

		if ( data != null ) {
			retorno = listaReservas.procurarData(data);
		}
		return retorno;

	}

	public boolean existe(Reserva reserva) {
		return listaReservas.existe(reserva);
	}

	public String toString() {
		return (listaReservas.toString());
	}

        public RepositorioReservaArray procuraReservasClienteData(Cliente cliente, GregorianCalendar data) {

		int i;
		RepositorioReservaArray repositorioAchados
			= new RepositorioReservaArray();

		for (i = 0; i < indice; i++) {
			if ( reservas[i].getCliente().equals(cliente) && reservas[i].getData().equals(data) ) {
				repositorioAchados.inserir(reservas[i]);
			}
		}

		return repositorioAchados;

	}


}