package br.ufpe.lp3.locadora.pedido;

import java.util.*;
import java.util.GregorianCalendar;
import java.util.Calendar;
import java.lang.String;
import br.ufpe.lp3.locadora.pedido.*;
import br.ufpe.lp3.locadora.cliente.*;
import br.ufpe.lp3.locadora.dvd.*;
import br.ufpe.lp3.locadora.conta.*;

/**
 * <p>Title: Locadora OnLine </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company:UFPE - CIN </p>
 * @author Hlio Jum Tonsho
 * @version 1.0
 */

public class RepositorioLocacaoArray {

	RepositorioReservaArray repositorioReserva;
	private Locacao[] locacoes;
	private int indice;
	private int tamanho;

	public RepositorioLocacaoArray() {
		tamanho = 1;
		locacoes = new Locacao[tamanho];
		indice = 0;
	}

	public boolean existe(Locacao locacao) {

		int i;
		boolean retorno = false;

		for (i = 0; i < indice; i++) {
			if (locacoes[i] != null){
				if (locacao.equals(locacoes[i])) {
					retorno =  true;
				}
			}
		}
		return retorno;

	}

	public void inserir(Locacao locacao) {

		int i;
		Locacao[] locacoesTemp;

		if ( indice == tamanho ) {

			locacoesTemp = locacoes;
			tamanho = tamanho + 20;
			locacoes = new Locacao[tamanho];

			for (i = 0; i < indice; i++) {
				locacoes[i] = locacoesTemp[i];
			}
		}
		locacoes[indice] = locacao;
		this.indice++;
		locacao.getDvd().setSituacao("Locado");

	}


	public RepositorioLocacaoArray procurar(String palavraChave) {

		int i;
		RepositorioLocacaoArray repositorioAchados
			= new RepositorioLocacaoArray();
		boolean a = false;
		boolean b = false;

		for (i = 0; i < indice; i++) {
			if ( locacoes[i].getCliente() != null ) {
				a = locacoes[i].getCliente().getNome()
				.equalsIgnoreCase(palavraChave);
			}
			if ( locacoes[i].getDvd() != null ) {
				b = locacoes[i].getDvd().getTitulo()
				.equalsIgnoreCase(palavraChave);
			}
			if ( a || b ) {
				repositorioAchados.inserir(locacoes[i]);
			}
		}
		return repositorioAchados;

	}

	public Locacao procurarCodigo(String codigo) {

		int i;
		Locacao locacao = null;

		for (i = 0; i < indice; i++) {
			if ( locacoes[i].getCodigo() != null ) {
				if (locacoes[i].getCodigo().equals(codigo)) {
					locacao = locacoes[i];
				}
			}
		}
		return locacao;

	}

	public RepositorioLocacaoArray procurarData(GregorianCalendar data) {

		RepositorioLocacaoArray repositorioAchados
			= new RepositorioLocacaoArray();
		int i;

		for (i=0; i < indice; i++) {
			if ( locacoes[i].getData().equals(data) ) {
				repositorioAchados.inserir(locacoes[i]);
			}
		}
		return repositorioAchados;

	}

	public void remover(Locacao locacao) {

		int i;

		if ( locacao != null ) {
			for (i = 0; i < indice; i++) {
				if (locacoes[i].equals(locacao) ) {
					locacoes[i] = locacoes[indice - 1];
					locacoes[indice-1] = null;
					indice = indice - 1;
					locacao.getDvd().setSituacao("Disponivel");
					return;
				}
			}
		}

	}

	public void atualizar(Locacao locacao) {

		int i;

		for (i = 0; i < indice; i++) {
			if (locacoes[i].equals(locacao)) {
				locacoes[i] = locacao;
			return;
			}
		}

	}

	public String toString() {

		int i;
		String s = "";
		int dia, mes, ano;

		for (i = 0; i < indice; i++) {
			dia = locacoes[i].getData().get(Calendar.DATE);
			mes = locacoes[i].getData().get(Calendar.MONTH) + 1;
			ano = locacoes[i].getData().get(Calendar.YEAR);
			s = s + "\nCodigo de locacao: " + locacoes[i].getCodigo()
				+ "\nData de locacao: " + dia + "/" + mes + "/" + ano
				+ "\nCliente: " + locacoes[i].getCliente().getNome()
				+ "\nCodigo do Dvd: " + locacoes[i].getDvd().getCodigo()
				+ "\nTitulo: " + locacoes[i].getDvd().getTitulo() + "\n";
		}
		return s;

	}

}