package br.ufpe.lp3.locadora.pedido;

import java.util.*;
import java.util.GregorianCalendar;
import java.util.Calendar;
import java.lang.String;
import br.ufpe.lp3.locadora.pedido.*;
import br.ufpe.lp3.locadora.cliente.*;
import br.ufpe.lp3.locadora.dvd.*;

/**
 * <p>Title: Locadora OnLine </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company:UFPE - CIN </p>
 * @author Hlio Jum Tonsho
 * @version 1.0
 */

public class RepositorioReservaArray {

	private Reserva[] reservas;
	private int indice;
	private int tamanho;

	public RepositorioReservaArray() {
		tamanho = 1;
		reservas = new Reserva[tamanho];
		indice = 0;
	}

	public boolean existe(Reserva reserva) {

		int i;
		boolean retorno = false;

		for (i = 0; i < indice; i++) {
			if (reservas[i] != null){
				if (reserva.equals(reservas[i])) {
					retorno =  true;
				}
			}
		}
		return retorno;

	}

	public void inserir(Reserva reserva) {

		int i;
		Reserva[] reservasTemp;

		if ( indice == tamanho ) {

			reservasTemp = reservas;
			tamanho = tamanho + 20;
			reservas = new Reserva[tamanho];

			for (i = 0; i < indice; i++) {
				reservas[i] = reservasTemp[i];
			}
		}

		reservas[indice] = reserva;
		this.indice++;
		reserva.getDvd().setSituacao("Reservado");

	}


	public RepositorioReservaArray procurar(String palavraChave) {

		int i;
		RepositorioReservaArray repositorioAchados
			= new RepositorioReservaArray();
		boolean a = false;
		boolean b = false;
		boolean c = false;

		for (i = 0; i < indice; i++) {
			if ( reservas[i].getCodigo() != null ) {
				a = reservas[i].getCodigo().equals(palavraChave);
			}
			if ( reservas[i].getCliente() != null ) {
				b = reservas[i].getCliente().getNome()
				.equalsIgnoreCase(palavraChave);
			}
			if ( reservas[i].getDvd() != null ) {
				c = reservas[i].getDvd().getTitulo()
				.equalsIgnoreCase(palavraChave);
			}
			if ( a || b || c ) {
				repositorioAchados.inserir(reservas[i]);
			}
		}
		return repositorioAchados;

	}

	public Reserva procurarCodigoDvd(String codigo) {

		int i;
		Reserva reserva = null;

		for (i = 0; i < indice; i++) {
			if ( reservas[i].getDvd().getCodigo() != null ) {
				if (reservas[i].getDvd().getCodigo().equals(codigo)) {
					reserva = reservas[i];
				}
			}
		}
		return reserva;

	}

	public RepositorioReservaArray procuraReservasClienteData(Cliente cliente, GregorianCalendar data) {

		int i;
		RepositorioReservaArray repositorioAchados
			= new RepositorioReservaArray();

		for (i = 0; i < indice; i++) {
			if ( reservas[i].getCliente().equals(cliente) && reservas[i].getData().equals(data) ) {
				repositorioAchados.inserir(reservas[i]);
			}
		}

		return repositorioAchados;

	}


	public RepositorioReservaArray procurarData(GregorianCalendar data) {

		RepositorioReservaArray repositorioAchados
			= new RepositorioReservaArray();
		int i;

		for (i=0; i < indice; i++) {
			if ( reservas[i].getData().equals(data) ) {
				repositorioAchados.inserir(reservas[i]);
			}
		}
		return repositorioAchados;

	}

      public void remover(Reserva reserva) {

		int i;

		if ( reserva != null ) {
			for (i = 0; i < indice; i++) {
				if (reservas[i].equals(reserva) ) {
					reservas[i] = reservas[indice - 1];
					reservas[indice-1] = null;
					indice = indice - 1;
					reserva.getDvd().setSituacao("Disponivel");
					break;
				}
			}
		}

	}


	public void atualizar(Reserva reserva) {

		int i;

		for (i = 0; i < indice; i++) {
			if (reservas[i].equals(reserva)) {
				reservas[i] = reserva;
			return;
			}
		}

	}

	public String toString() {

		int i;
		String s = "";
		int dia, mes, ano;

		for (i = 0; i < indice; i++) {
			dia = reservas[i].getData().get(Calendar.DATE);
			mes = reservas[i].getData().get(Calendar.MONTH) + 1;
			ano = reservas[i].getData().get(Calendar.YEAR);
			s = s + "\nCodigo de reserva: " + reservas[i].getCodigo()
				+ "\nData de reserva: " + dia + "/" + mes + "/" + ano
				+ "\nCliente: " + reservas[i].getCliente().getNome()
				+ "\nCodigo do Dvd: " + reservas[i].getDvd().getCodigo()
				+ "\nTitulo: " + reservas[i].getDvd().getTitulo() + "\n";
		}
		return s;

	}

}