package br.ufpe.lp3.locadora.pedido;

import java.util.*;
import java.util.GregorianCalendar;
import java.util.Calendar;
import java.lang.String;
import br.ufpe.lp3.locadora.dvd.*;
import br.ufpe.lp3.locadora.cliente.*;

/**
 * <p>Title: Locadora OnLine </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company:UFPE - CIN </p>
 * @author Hlio Jum Tonsho
 * @version 1.0
 */

public class Reserva {

	private Dvd dvd;
	private Cliente cliente;
	private GregorianCalendar data;
	private String codigo;
	private String situacao;
	private static int scodigo = 999;

	public Reserva(Dvd dvd, Cliente cliente, GregorianCalendar data) {
		this.dvd = dvd;
		this.cliente = cliente;
		this. data = data;
		scodigo++;
		this.codigo = "RES-" + Integer.toString(scodigo);
	}


	public Dvd getDvd() {
		return dvd;
	}

	public void setDvd(Dvd dvd) {
		this.dvd = dvd;
	}

	public Cliente getCliente() {
		return cliente;
	}

	public void setCliente(Cliente cliente) {
		this.cliente = cliente;
	}

	public GregorianCalendar getData() {
		return data;
	}

	public void setCategoria(GregorianCalendar data) {
		this.data = data;
	}

	public String getCodigo() {
		return codigo;
	}

	public void setCodigo(String codigo) {
		this.codigo = codigo;
	}

	public String getSituacao() {
		return situacao;
	}

	public void setSituacao(String situacao) {
		this.situacao = situacao;
	}

	public String toString() {

		int dia = this.getData().get(Calendar.DATE);
		int mes = this.getData().get(Calendar.MONTH) + 1;
		int ano = this.getData().get(Calendar.YEAR);

		return( "\nCodigo de reserva: " + this.getCodigo()
				+ "\nData de reserva: " + dia + "/" + mes + "/" + ano
				+ "\nCliente: " + this.cliente.getNome()
				+ "\nCodigo do Dvd: " + this.dvd.getCodigo()
				+ "\nTitulo: " + this.dvd.getTitulo() );

	}

	public boolean equals(Reserva reserva) {
		return ( this.codigo.equals(reserva.getCodigo())
				 && this.dvd.equals(reserva.getDvd())
				 && this.cliente.equals(reserva.getCliente())
				 && this.data.equals(reserva.getData()));
	}

}