/**
 * <p>Title: Locadora OnLine </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company:UFPE - CIN </p>
 * @author Helder Teixeira Rodrigues
 * @version 1.0
 */

package br.ufpe.lp3.locadora.util;

/**
* Esta classe modela um Endereco.
*
* @author: Maurikleber, Modificado por Helder
*
* @copyright: Larcio, Maurikleber, Helder, Hlio
*/
public class Endereco {


    public String rua;
    public String bairro;
    public String cep;
    public String numero;

    /**
    *construtor default da classe endereco
    *
    */
    public Endereco() {
        rua = "";
        bairro = "";
        numero = "";
        cep = "";
    }

    /**
    * segundo construtor da classe endereco
    *
    *@param rua
    *@param bairro
    *@param numero
    *@param cep
    */
    public Endereco(String rua, String bairro, String numero, String cep){
        this.rua = rua;
        this.bairro = bairro;
        this.numero = numero;
        this.cep = cep;

    }

    /**
    *Este metodo ajusta o campo rua
    *
    *@param Um string contendo o nome da rua
    */
    public void setRua(String rua){
        this.rua = rua;

    }

    /**
    *Este metodo retorna o valor do campo rua
    *
    *@return um string contendo o campo rua
    */
    public String getRua(){
        return rua;

    }

    /**
    *Este metodo ajusta o campo bairro
    *
    *@param Um String contendo o nome do bairro
    */
    public void setBairro(String bairro){
        this.bairro = bairro;

    }

    /**
    *Este metodo retorna a informacao do campo bairro ,
    *
    *@return Um String contendo o nome do bairro
    */
    public String getBairro(){
        return bairro;

    }

    /**
    *Este metodo ajusta a informacao do campo cep
    *
    *@param Um String contendo o cep
    */
    public void setCep(String cep){
        this.cep = cep;

    }

    /**
    *Este metodo retorna o valor do campo cep
    *
    *@return Um String contendo o numero do cep
    */
    public String getCep(){
        return cep;

    }

    /**
    *Este metodo ajusta o valor do campo numero
    *
    *@param Um String contendo numero da rua
    */
    public void setNumero(String numero){
        this.numero = numero;

    }

    /**
    *Este metodo retorna uma String contendo numero da rua
    *
    *@return O numero da rua
    */
    public String getNumero(){
        return numero;
    }

    /**
    *Este metodo retorna a representacao String da classe Endereco
    *
    *@return Um String contendo os valores dos campos da classe
    */
    public String toString(){
        return "Rua: " + rua + ", numero: " + numero + ", bairro: " + bairro
                + ", cep: " + cep;

    }

}



