package br.ufpe.lp3.locadora.util;

/**
 * <p>Title: Locadora OnLine </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company:UFPE - CIN </p>
 * @author Larcio
 * @version 1.0
 */

public class FichaTecnicaDvd {

    private int anoProducao;        // Ano da producao do filme
    private String audio;           // Dolby Digital, Dolby Surround, etc.
    private String cor;             // Colorido ou P & B.
    private String genero;          // Genero
    private int duracao;            // Duracao do filme em minutos!
    private String formato;         // Widescreen,etc.
    private String idiomaOriginal;  // Idioma original
    private String idiomas;         // Idiomas para os quais existen dublagem
    private String legendas;        // Idiomas para os quais existen legendas
    private char regiao;            // 0,1,2,3,4
    private String origem;          // Pais de producao
    private String tituloOriginal;  // Titulo Original

   /**
    * Construtor da classe FichaTecnica (default)
    */
    public FichaTecnicaDvd() {
    }

   /**
    * Retorna o titulo original do filme
    *
    * @return       Uma String contendo o titulo original do filme
    */
    public String getTituloOriginal(){
        return tituloOriginal;
    }

   /**
    * Ajusta o titulo original do Dvd.
    *
    * @param        Uma String contendo o titulo original do filme
    */
    public void setTituloOriginal (String tituloOriginal) {
        this.tituloOriginal = tituloOriginal;
    }

   /**
    * Retorna todos os idiomas possiveis para o filme (original e dublagens)
    *
    * @return       Uma String contendo os nomes dos idiomas em que o filme pode
    *               ser visto
    */
    public String getIdiomas(){
        return idiomas;
    }

   /**
    * Ajusta os nomes do idiomas do DVD
    *
    * @param        Uma String contendo os nomes dos idiomas em que o filme pode
    *               ser visto
    */
    public void setIdiomas (String idiomas) {
        this.idiomas = idiomas;
    }

   /**
    * Retorna todas as linguas em que ha legendas para o filme
    *
    * @return       Uma String contendo o nome dos idiomais para os quais ha
    *               legendas
    */
    public String getLegendas(){
        return legendas;
    }

   /**
    * Ajusta os nomes dos idiomas para os quais ha legendas
    *
    * @param        Uma String contendo o nome dos idiomais para os quais ha
    *               legendas
    */
    public void setLegendas (String legendas) {
        this.legendas = legendas;
    }

   /**
    * Retorna o pais de producao do filme
    *
    * @return       Uma String contendo o nome do pais de producao do filme
    */
    public String getOrigem(){
        return origem;
    }

   /**
    * Ajusta o nome do pais de origem do filme
    *
    * @param        Uma String contendo o nome do pais de producao do filme
    */
    public void setOrigem (String origem) {
        this.origem = origem;
    }

   /**
    * Retorna a regiao do DVD
    *
    * @return       Um caracter indicando a regiao a que pertence o dvd
    */
    public char getRegiao(){
        return regiao;
    }

   /**
    * Ajusta o numero (char) da regiao
    *
    * @param        Um caracter indicando a regiao a que pertence o dvd
    */
    public void setRegiao (char regiao) {
        this.regiao = regiao;
    }

   /**
    * Retorna o formato de exibicao do filme
    *
    * @return       Uma String informando a forma em que o filme aparece na tela
    */
    public String getFormato(){
        return formato;
    }

   /**
    * Ajusta o nome do formato de exibicao do filme
    *
    * @param        Uma String informando a forma em que o filme aparece na tela
    */
    public void setFormato(String formato) {
        this.formato = formato;
    }

   /**
    * Retorna a duracao do filme (em minutos)
    *
    * @return       Um inteiro contendo a duracao do filme em minutos
    */
    public int getDuracao(){
        return duracao;
    }

   /**
    * Ajusta a duracao do DVD
    *
    * @param        Um inteiro contendo a duracao do filme em minutos
    */
    public void setDuracao(int duracao) {
        this.duracao = duracao;
    }

   /**
    * Retorna a cor do filme (colorido ou P & B)
    *
    * @return       Uma String informando se o filme  colorido ou P&B
    */
    public String getCor(){
        return cor;
    }

   /**
    * Ajusta o filme em colorido ou P&B
    *
    * @param        Uma String informando se o filme  colorido ou P&B
    */
    public void setCor (String cor) {
        this.cor = cor;
    }

   /**
    * Retorna o formato do audio
    *
    * @return       Uma String contendo o formato do audio
    */
    public String getAudio(){
        return audio;
    }

   /**
    * Ajusta o formato do audio
    *
    * @param        Uma String contendo o formato do audio
    */
    public void setAudio(String audio) {
        this.audio = audio;
    }

   /**
    * Retorna o ano de producao do filme
    *
    * @return       Um inteiro contendo o ano em que o filme foi produzido
    */
    public int getAnoProducao(){
        return anoProducao;
    }

   /**
    * Ajusta o ano de producao
    *
    * @param        Um inteiro contendo o ano em que o filme foi produzido
    */
    public void setAnoProducao(int anoProducao) {
        this.anoProducao  =  anoProducao;
    }

   /**
    * Retorna o genero do filme
    *
    * @return       Uma String contendo o genero do filme
    */
    public String getGenero(){
        return genero;
    }

   /**
    * Ajusta o genero do filme
    *
    * @param        Uma String contendo o genero do filme
    */
    public void setGenero(String genero) {
        this.genero = genero;
    }

   /**
    * Retorna o idioma original do filme
    *
    * @return       Uma String contendo o idioma original do filme
    */
    public String getIdiomaOriginal(){
        return idiomaOriginal;
    }

   /**
    * Ajusta o idioma original
    *
    * @param        Uma String contendo o idioma original do filme
    */
    public void setIdiomaOriginal (String idiomaOriginal) {
        this.idiomaOriginal = idiomaOriginal;
    }

    public String toString() {
        return ("\nTitulo Original: " + this.getTituloOriginal()
                + "\nGenero: " + this.getGenero()
                + "\nIdioma Original: " + this.getIdiomaOriginal()
                + "\nIdiomas: " + this.getIdiomas()
                + "\nGenero: " + this.getGenero()
                + "\nOrigem: " + this.getOrigem()
                + "\nRegiao: " + this.getRegiao()
                + "\nDuracao: " + this.getDuracao()
                + "\nLegendas: " + this.getLegendas()
                + "\nAno Producao: " + this.getAnoProducao()
                + "\nAudi: " + this.getAudio()
                + "\nFormato: " + this.getFormato());
        }

}
